﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace howto_palindrome_dates
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            txtDate.Text = DateTime.Now.ToString("d");
        }

        private void btnGo_Click(object sender, EventArgs e)
        {
            lstDates.Items.Clear();

            // Date formats.
            string[] formats;
            if (radMdy.Checked)
            {
                // m/d/y formats.
                formats = new string[]
                {
                    "Mdyy",
                    "MMddyy",
                    "Mdyyyy",
                    "MMddyyyy",
                };
            }
            else if (radDmy.Checked)
            {
                // d/m/y formats.
                formats = new string[]
                {
                    "dMyy",
                    "ddMMyy",
                    "dMyyyy",
                    "ddMMyyyy",
                };
            }
            else
            {
                // y/m/d formats.
                formats = new string[]
                {
                    "yyMd",
                    "yyMMdd",
                    "yyyyMd",
                    "yyyyMMdd",
                };
            }

            DateTime date = DateTime.Parse(txtDate.Text);
            int num_dates = int.Parse(txtNumDates.Text);
            for (int i = 0; i < num_dates; i++)
            {
                List<string> palindromes = new List<string>();
                foreach (string format in formats)
                {
                    string date_string = date.ToString(format);
                    if (!palindromes.Contains(date_string) &&
                        (date_string == Reverse(date_string)))
                    {
                        lstDates.Items.Add(date_string);
                        palindromes.Add(date_string);
                    }
                }

                date = date.AddDays(1);
            }
        }

        private string Reverse(string value)
        {
            return new string(value.ToCharArray().Reverse().ToArray());
        }
    }
}
